package de.fraunhofer.iem.dataprovider.gitlab.controller

import de.fraunhofer.iem.dataprovider.configuration.ApiPaths
import de.fraunhofer.iem.dataprovider.gitlab.dto.RepositoryChangedDto
import de.fraunhofer.iem.dataprovider.kpi.metrics.MetricsService
import de.fraunhofer.iem.dataprovider.logger.getLogger
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RestController


@RestController
class GitlabController(private val metricsService: MetricsService) {

    private val logger = getLogger(javaClass)

    // TODO: if the parsing of the request body fails we send a stack
    //  trace back this should be changed to a custom error.
    @PostMapping(ApiPaths.OPENCODE_REPO_CHANGED)
    suspend fun repoChanged(@RequestBody repositoryChangedDto: RepositoryChangedDto) {
        logger.info("Repo changed POST request for ID ${repositoryChangedDto.projectId} received.")
        metricsService.handleRepositoryChange(repositoryChangedDto.projectId)
    }
}
